'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; /* global MathJax */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _marked = require('marked');

var _marked2 = _interopRequireDefault(_marked);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_MATHJAX_CONF = {
  tex2jax: { inlineMath: [['$', '$']] }
};

var DEFAULT_MARKED_CONF = {
  gfm: true,
  tables: true,
  breaks: false,
  smartLists: true,
  smartypants: false
};

function merge(def, custom) {
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = Object.keys(custom)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var key = _step.value;

      if (_typeof(def[key]) === 'object') {
        def[key] = merge(def[key], custom[key]);
      } else {
        def[key] = custom[key];
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return def;
}

var MathDown = function (_Component) {
  _inherits(MathDown, _Component);

  function MathDown(props) {
    _classCallCheck(this, MathDown);

    var _this = _possibleConstructorReturn(this, (MathDown.__proto__ || Object.getPrototypeOf(MathDown)).call(this, props));

    _this.setNode = function (key, node) {
      _this[key] = node;
    };

    _this.renderMarkdown = function () {
      // textify
      var text = Array.from(_this.buffer.childNodes).map(function (child) {
        if (child.nodeType === 3) {
          // TextNode may contain characters like (&), (<), or (>)
          // innerHTML returns these characters as &amp, &lt and &gt respectively
          return child.nodeValue;
        } else {
          return child.outerHTML;
        }
      }).join('');
      var result = (0, _marked2.default)(text);
      // no need to trigger render() again
      _this.node.innerHTML = result;
      // FIXME: How can I get rid of the redundant data?
      //this.buffer.innerHTML = ''
    };

    var markedConfig = DEFAULT_MARKED_CONF;
    var jaxConfig = DEFAULT_MATHJAX_CONF;
    if (props.markedConfig) {
      markedConfig = merge(markedConfig, props.markedConfig);
    }
    if (props.jaxConfig) {
      jaxConfig = merge(jaxConfig, props.jaxConfig);
    }
    // IMPORTANT, because we do MathJax before markdown
    markedConfig.sanitize = false;
    _marked2.default.setOptions(markedConfig);
    MathJax.Hub.Config(jaxConfig);
    return _this;
  }

  _createClass(MathDown, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      return this.queue();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      return this.queue();
    }
  }, {
    key: 'queue',
    value: function queue() {
      MathJax.Hub.Queue(['Typeset', MathJax.Hub, this.buffer], this.renderMarkdown);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          value = _props.value,
          jaxConfig = _props.jaxConfig,
          markedConfig = _props.markedConfig,
          others = _objectWithoutProperties(_props, ['value', 'jaxConfig', 'markedConfig']);

      return _react2.default.createElement(
        'div',
        others,
        _react2.default.createElement('div', {
          style: { display: 'none' },
          ref: this.setNode.bind(this, 'buffer'),
          dangerouslySetInnerHTML: { __html: value }
        }),
        _react2.default.createElement('div', { ref: this.setNode.bind(this, 'node') })
      );
    }
  }]);

  return MathDown;
}(_react.Component);

MathDown.propTypes = {
  jaxConfig: _propTypes2.default.object,
  markedConfig: _propTypes2.default.object,
  value: _propTypes2.default.string
};
exports.default = MathDown;